<?php
/*
http://forum.phpfrance.com/xml/page-xml-retour-ligne-t36349.html#p270069

module: Création d'un flux RSS à partir du module news
Par Adrien Poreaux avec modif par Christian ;-)
Licence Creative Commons CC-BY-NC-SA

D'après le module:	Création d'un serveur RSS et d'un lecteur RSS
	Version 1.3 intégrée dans ziteplus 0.9.2
	Copyright Jean-Paul GIAUSSERAND 2010-2011
	Site: http://www.giausserand.fr/index.php?perma=ziteplus
	Licence : Creative Commons CC-BY-NC-SA
	
Historique:
	1.0 - Adaptation du module news
*/
class Trss_news extends Tmodule {
	protected function makeRSS(){
	  function ischild($ancestor,$descendant){
	  	while ((Tmodule::$cms->struct[$descendant][cPagePere]!=$ancestor) && (Tmodule::$cms->struct[$descendant][cPageRang]!=1)&&($descendant>1))
				$descendant = Tmodule::$cms->struct[$descendant][cPagePere];
			return TModule::$cms->struct[$descendant][cPagePere]==$ancestor;
		};
		function normaliser($s) {
			return utf8_encode(html_entity_decode($s,ENT_COMPAT,'ISO-8859-15')); // mettre en parametre le ISO-8859-15
		}
		function notag($s){
			return  trim(preg_replace('@(<br />)+@is','<br />',  str_replace(array('<br/>','<br>'),array('<br />','<br />'),strip_tags($s,'<li><br>'))));
		}
		$logo=$this->getOption('logo');
		$lang=$this->getOption('lang');
		$ttl=$this->getOption('ttl');
		$page_news=$this->getOption('page_news');	//	'.$page_news.'	flux_news.xml  A Faire pour modif page
		$out='';
		$out.='<?xml version="1.0" encoding="UTF-8"?'.'><rss version="2.0">';
		$out.='<channel>';
		$out.='<title>'.normaliser(self::$cms->get_data('site_title').' '.self::$cms->get_data('site_subtitle')).'</title>';
		$out.='<description>'.normaliser(self::$cms->get_data('site_description')).'</description>';
	    $out.='<link>'.self::$cms->makeURL(0,true).'</link>';
			$out.='<language>'.$lang.'</language>';
			$out.='<generator>Module RSS_News ZitePLUS-Module RSS, V1.0 ,Licence Creative Commons CC-BY-NC-SA</generator>';/*cette ligne ne doit pas être altérée pour respcter la licence*/
			$out.='<ttl>'.$ttl.'</ttl>';//en minutes
			$out.='<pubDate>'.date("r", filemtime(self::$cms->ipath.'/flux_news.xml')).'</pubDate>';
	    $out.='<lastBuildDate>'.date("r", filemtime(self::$cms->cpath.'/news.dta')).'</lastBuildDate>';
			if (isset($logo)) $out.='<image><url>'.self::$cms->rewritebase.'thumb.php/'.$logo.'</url><title>'.normaliser(self::$cms->get_data('site_title').' '.self::$cms->get_data('site_subtitle')).'</title><link>'.self::$cms->makeURL(0,true).'</link></image>';
			$base = self::$cms->rewrite ? '' : self::$cms->base;
	//Suppression du code initial
/*			$max = count(self::$cms->struct);
			$istart=self::$cms->page_from_ident($this->getOption('basepage'));
			if (empty($istart)) {
			  $istart=1;
			  $iend=$max+1;
			} else {
			  $iend=$istart+1;
			  while (ischild($istart,$iend)&&($iend<=$max)) ++$iend;
			}
			for ($i=$istart; $i<$iend; $i++) {//!! il faut restreindre aux pages visibles par tout lemonde !!!
				if (self::$cms->isPageAuth($i,cPageRead,array('all'))) {//modif 091
					$page = self::$cms->struct[$i];
					if ($page[cPageOn] && (($page[cPageType]&pgbitType)!=5)&&($page[cPageIdent][0]!='_')) {
				 		$out .= '<item>';
				 		$out .= '<title>'.utf8_encode(html_entity_decode($page[cPageTitre])).'</title>';
				 		$out .= '<description><![CDATA['.normaliser(isset($page[cPageDesc])?$page[cPageDesc]:notag(file_get_contents(self::$cms->cpath.'/'.$page[cPageIdent].'.txt'))).']]></description>';
	  		$out .= '<link>'.self::$cms->makeURL($i,true).'</link>';
				 		$out .= '<guid>'.self::$cms->makeURL($i,true).'</guid>';
			  		$out .= '<pubDate>'.date("r", filemtime(self::$cms->cpath.'/'.$page[cPageIdent].'.txt')).'</pubDate>';
						$out .= '</item>';
	  	    }
				}
			}
*/
		//Gestion du module news
		if (empty(self::$cms->news)) self::$cms->news = (array)unserialize(@file_get_contents(self::$cms->cpath.'/news.dta'));
		foreach (self::$cms->news as $value){
			$time = array();
			//d/m/Y H:i
			preg_match('#^([0-9]*)/([0-9]*)/([0-9]*) ([0-9]*):([0-9]*)$#',$value[3],$time);

			$textenews = '<![CDATA['.normaliser($value[2]).']]>';	// Traitement des infos
			$textenews2 = substr ($textenews, 0, 420);

			$out .= '<item>';
			$out .= '<title>'.normaliser($value[1]).'</title>';
			$out .= '<description>'.$textenews2.'&nbsp;&nbsp;... <i>(lire la suite sur le site)</i></p>]]></description>';
			$out .= '<guid isPermaLink="false"></guid>';
			$out .= '<link>index.php?perma=news</link>';
			$out .= '<pubDate>'.date('r',mktime($time[4],$time[5],0,$time[2],$time[1],$time[3])).'</pubDate>';
			$out .= '</item>';

		}// fin module news

		$out.= '</channel></rss>';
  		return self::$cms->writefile(self::$cms->ipath.'/flux_news.xml',$out);
	}
	function dojob($opt="") {
		//
	  parent::dojob();
		$out='';
	  $logo=$this->getOption('logo');
	  $ttl=$this->getOption('ttl');
	  $lang=$this->getOption('lang');
		if (isset($_POST['submit'])) { // génération sitemapXML
			//
			$this->makeRSS()?self::$cms->msgShow('done_ok'):self::$cms->msgShow('done_failed');
			$out = '';
		}
		$out .= '<form method="post" action="'.self::$cms->base.'module|'.$this->modulename.'" enctype="multipart/form-data"><table class="ztable">';
		$out2= ($this->isConfig($this->modulename)?'<a href="'.self::$cms->base.'selectmodule|config|'.$this->ident.'" title="'.$this->get_message('moduleconf').'"><img src="deco/config.png"/></a>':'');
		$out .= '<tr><td colspan="2" style="text-align:center"><span style="float:right">'.$out2.'</span><center><strong>'.$this->get_message('title').'</strong></center></td></tr>';
		$out .= '<tr><td colspan="2">'.$this->get_message('intro').'</td></tr>';
		//
		$out.='<tr><td width="150px"></td><td></td></tr>';
		//
		$out .= '<tr><td colspan="2"><input type="submit" name="submit" value="'.self::$cms->get_message('submit').'" /></td></tr></table></form>';
		if (file_exists(self::$cms->ipath.'/flux_news.xml')) {
		  $out .= '<table class="ztable">';
		  $out .= '<tr><td>'.$this->get_message('rssfiledate').date("d/m/Y à H:m:s", filemtime(self::$cms->ipath.'/flux_news.xml')).'</td></tr>';
			$out .= '<tr><td><textarea rows=30 cols=70 wrap=on readonly>'.str_replace('<url',"\n<url",file_get_contents(self::$cms->ipath.'/flux_news.xml')).' </textarea></td></tr>';
		  $out .= '</table>';
		}
		return $out;
	}
	protected function Register() {//Appelé lorsque le module est activé
		self::$cms->register_event(eHead,eBefore,$this->modulename);
		self::$cms->register_event(eLogout,eBefore,$this->modulename);
	}
	function Event($event,$mode,&$out,$opt=null) {
	  if ($event==eHead && $mode==eBefore){
  		$out.='<link rel="alternate" type="application/rss+xml" title="RSS" href="'.self::$cms->makeURL(0,true).'flux_news.xml" />';
		} else if ($event==eLogout && $mode==eBefore && $this->getOption('rssauto')){
		  	if (!empty($_SESSION['zite_usergroup'])&&($_SESSION['zite_usergroup']!=array('logon'))){
			   if (filemtime(self::$cms->ipath.'/flux_news.xml')<filemtime(self::$cms->cpath.'/news.dta') ) {
					if (!$this->makeRSS()) {
						self::$cms->msgShow('Génération auto flux RSS');
						self::$cms->msgShow('done_failed');
					}
				}
			}
		}
	}
	function On(){
		parent::On();
		self::$cms->msgShow($this->get_message("versionbeta"),false);
	}
}
?>
